
#### Step IV: refinement ####

################################################ SAEM for gene data ( each cluster )  ######################################

#### import gene data for each cluster ###

### gene.all = read.table()
gene.all = my.sample
gene = gene.all[1:5,]
n.obs = ncol( gene )
n.sub = nrow( gene )
n.tot = n.obs * n.sub

#### some parms #####

M1 = 100
M2 = 110
n.par = 4

#### ODE parms #####
tot.time = 10

fold = 5

n.step = ( pp - 1 ) * 2 * fold

grd = tot.time * 2 / n.step

#### for 'predict' below, 'my.time' is handled here ####

time.step = 1/2/fold

#### set up matrix ####

parm = matrix( 0, nrow = n.sub, ncol = n.par )
s1 = matrix( 0, nrow = n.sub, ncol = n.par )
s1m = rep( 0, n.par )
s2m = rep( 0, n.par )
s3 = rep( 0, n.sub )
s3m = 0
trace.mu = matrix( nrow =  M2 , ncol = n.par )
trace.omg = matrix( nrow =  M2 , ncol =  n.par )

#### initial value ####

mu = c( 0.02, -1.22, 2.41, -3.31 )  ### need constant term as well
omg = diag(c( 1, 5, 5, 5 ))

#### main program ####

for ( i in 1:n.sub )  {

   draw <- rmvnorm(n=1, mean=mu, sigma=omg, method="chol")

   s1[i, ] = draw


 ####  set up ini. cond'n for ODE of subjec i ####

  ca0 = gene[i,1]  #### -0.25
  cb0 = curvR.t2[2,1]  ####1.5

  cc0 = curvR.t2[3,1]   ####0.4

  cd0 = curvR.t2[4,1]   ####-1.9

 ####  slove ODE ####

   i.step = 1

 while( i.step <= n.step / 2 ) {
  #### reorder the result 'ssafitX' SO be careful here to choose correct order of ssafitX  ####

   cbt0.5 = predict(ssafit3,data.frame(my.time= 1 + ( 2 * i.step - 1 ) * time.step ),se.fit=FALSE)

   cbt1.0 = predict(ssafit3,data.frame(my.time= 1 + 2 * i.step * time.step ),se.fit=FALSE)

   cdt0.5 = predict(ssafit4,data.frame(my.time= 1 + ( 2 * i.step - 1 ) * time.step  ),se.fit=FALSE)

   cdt1.0 = predict(ssafit4,data.frame(my.time= 1 + 2 * i.step * time.step ),se.fit=FALSE)

   ca1 = draw[ 1 ] + draw[ 2 ]  * ca0 + draw[ 3 ]  * cb0 + draw[ 4 ]  * cd0

   ca2 = draw[ 1 ]  + draw[ 2 ]  * ( ca0 +  0.5 * ca1 * grd ) + draw[ 3 ]  * cbt0.5 + draw[ 4 ] * cdt0.5

   ca3 = draw[ 1 ]  + draw[ 2 ]  * ( ca0 +  0.5 * ca2 * grd ) + draw[ 3 ]  * cbt0.5 + draw[ 4 ] * cdt0.5

   ca4 = draw[ 1 ]  + draw[ 2 ]  * ( ca0 +   ca3 * grd ) + draw[ 3 ]  * cbt1.0 + draw[ 4 ] * cdt1.0



   ca = ca0 + grd * ( ca1 + 2 * ca2 + 2 * ca3 + ca4 ) / 6


   ca0 = ca

   cb0 = cbt1.0

   cd0 = cdt1.0

#####   curv.rk[i+1,1] = ca0
   if ( i.step %% fold == 0) {

     pick.time = i.step %/% fold + 1

    s3[ i ] = s3[ i ] + ( gene[ i, pick.time ] - ca0 )^2

   }

   i.step = i.step + 1
 }

  s1m = s1m + draw

  s2m = s2m + draw^2

  s3m = s3m + s3[ i ]

}

hat.mu = s1m / n.sub

diag.elem = as.vector ( s2m / n.sub - hat.mu ^ 2 )

hat.omg = diag( diag.elem )

hat.sig2 = s3m / n.tot

hat.sig = sqrt( hat.sig2 )


##### start M-H  for each subject ####

ga = 1

iter = 1

while ( iter <= M1 ) {

s1m = rep( 0, n.par )

s2m = rep( 0, n.par )

s3m = 0

s3.new = rep( 0, n.sub )

for ( i in 1:n.sub )  {

   draw <- rmvnorm(n=1, mean= hat.mu, sigma= hat.omg, method="chol")


 ####  set up ini. cond'n for ODE of subjec i ####

  ca0 = gene[i,1]  #### -0.25

  cb0 = curvR.t2[2,1]  ####1.5

  cc0 = curvR.t2[3,1]   ####0.4

  cd0 = curvR.t2[4,1]   ####-1.9

 ####  slove ODE ####

   i.step = 1

 while( i.step <= n.step / 2 ) {
  #### reorder the result 'ssafitX' SO be careful here to choose correct order of ssafitX  ####

   cbt0.5 = predict(ssafit3,data.frame(my.time= 1 + ( 2 * i.step - 1 ) * time.step ),se.fit=FALSE)

   cbt1.0 = predict(ssafit3,data.frame(my.time= 1 + 2 * i.step * time.step ),se.fit=FALSE)

   cdt0.5 = predict(ssafit4,data.frame(my.time= 1 + ( 2 * i.step - 1 ) * time.step  ),se.fit=FALSE)

   cdt1.0 = predict(ssafit4,data.frame(my.time= 1 + 2 * i.step * time.step ),se.fit=FALSE)

   ca1 = draw[ 1 ] + draw[ 2 ]  * ca0 + draw[ 3 ]  * cb0 + draw[ 4 ]  * cd0

   ca2 = draw[ 1 ]  + draw[ 2 ]  * ( ca0 +  0.5 * ca1 * grd ) + draw[ 3 ]  * cbt0.5 + draw[ 4 ] * cdt0.5

   ca3 = draw[ 1 ]  + draw[ 2 ]  * ( ca0 +  0.5 * ca2 * grd ) + draw[ 3 ]  * cbt0.5 + draw[ 4 ] * cdt0.5

   ca4 = draw[ 1 ]  + draw[ 2 ]  * ( ca0 +   ca3 * grd ) + draw[ 3 ]  * cbt1.0 + draw[ 4 ] * cdt1.0


   ca = ca0 + grd * ( ca1 + 2 * ca2 + 2 * ca3 + ca4 ) / 6


   ca0 = ca

   cb0 = cbt1.0

   cd0 = cdt1.0

#####   curv.rk[i+1,1] = ca0
   if ( i.step %% fold == 0) {

     pick.time = i.step %/% fold + 1

     s3.new[ i ] = s3.new[ i ] + ( gene[ i, pick.time ] - ca0 )^2

   }

   i.step = i.step + 1
 }

  delta = ( s3[ i ] - s3.new[ i ] ) / hat.sig2

  delta = exp ( delta / 2 )

  u = runif( 1 )

  if ( u <= delta ) {

    s3[ i ] = s3.new[ i ]

    s1[ i, ] = draw

  }

  s1m = s1m + s1[ i, ]

  s2m = s2m + s1[ i, ]^2

  s3m = s3m + s3[ i ]

}

 hat.mu = s1m / n.sub

 diag.elem = as.vector ( s2m / n.sub - hat.mu ^ 2 )

 hat.omg = diag( diag.elem )

 trace.mu[ iter, ] = hat.mu

 trace.omg[ iter, ] = s2m / n.sub - hat.mu ^ 2

 hat.sig2 = s3m / n.tot

 hat.sig = sqrt( hat.sig2 )

iter = iter + 1

 }

while ( iter <= M2 ) {

s1m.new = rep( 0, n.par )

s2m.new = rep( 0, n.par )

s3m.new = 0

s3.new = rep( 0, n.sub )

for ( i in 1:n.sub )  {

   draw <- rmvnorm(n=1, mean= hat.mu, sigma= hat.omg, method="chol")


 ####  set up ini. cond'n for ODE of subjec i ####

  ca0 = gene[i,1]  #### -0.25

  cb0 = curvR.t2[2,1]  ####1.5

  cc0 = curvR.t2[3,1]   ####0.4

  cd0 = curvR.t2[4,1]   ####-1.9

 ####  slove ODE ####

   i.step = 1

 while( i.step <= n.step / 2 ) {
  #### reorder the result 'ssafitX' SO be careful here to choose correct order of ssafitX  ####

   cbt0.5 = predict(ssafit3,data.frame(my.time= 1 + ( 2 * i.step - 1 ) * time.step ),se.fit=FALSE)

   cbt1.0 = predict(ssafit3,data.frame(my.time= 1 + 2 * i.step * time.step ),se.fit=FALSE)

   cdt0.5 = predict(ssafit4,data.frame(my.time= 1 + ( 2 * i.step - 1 ) * time.step  ),se.fit=FALSE)

   cdt1.0 = predict(ssafit4,data.frame(my.time= 1 + 2 * i.step * time.step ),se.fit=FALSE)

   ca1 = draw[ 1 ] + draw[ 2 ]  * ca0 + draw[ 3 ]  * cb0 + draw[ 4 ]  * cd0

   ca2 = draw[ 1 ]  + draw[ 2 ]  * ( ca0 +  0.5 * ca1 * grd ) + draw[ 3 ]  * cbt0.5 + draw[ 4 ] * cdt0.5

   ca3 = draw[ 1 ]  + draw[ 2 ]  * ( ca0 +  0.5 * ca2 * grd ) + draw[ 3 ]  * cbt0.5 + draw[ 4 ] * cdt0.5

   ca4 = draw[ 1 ]  + draw[ 2 ]  * ( ca0 +   ca3 * grd ) + draw[ 3 ]  * cbt1.0 + draw[ 4 ] * cdt1.0

    ca = ca0 + grd * ( ca1 + 2 * ca2 + 2 * ca3 + ca4 ) / 6

   ca0 = ca

   cb0 = cbt1.0

   cd0 = cdt1.0

#####   curv.rk[i+1,1] = ca0
   if ( i.step %% fold == 0) {

     pick.time = i.step %/% fold + 1

     s3.new[ i ] = s3.new[ i ] + ( gene[ i, pick.time ] - ca0 )^2

   }

   i.step = i.step + 1
 }

  delta = ( s3[ i ] - s3.new[ i ] ) / hat.sig2

  delta = exp ( delta / 2 )

  u = runif( 1 )

  if ( u <= delta ) {

    s3[ i ] = s3.new[ i ]

    s1[ i, ] = draw

  }

  s1m.new = s1m.new + s1[ i, ]

  s2m.new = s2m.new + s1[ i, ]^2

  s3m.new = s3m.new + s3[ i ]

}

 ga = 1 / ( iter - M1 )

 s1m = ( 1 - ga ) * s1m + ga * s1m.new

 s2m = ( 1 - ga ) * s2m + ga * s2m.new

 s3m = ( 1 - ga ) * s3m + ga * s3m.new

 hat.mu = s1m / n.sub

 diag.elem = as.vector ( s2m / n.sub - hat.mu ^ 2 )

 hat.omg = diag( diag.elem )

 trace.mu[ iter, ] = hat.mu

 trace.omg[ iter, ] = s2m / n.sub - hat.mu ^ 2

 hat.sig2 = s3m / n.tot

 hat.sig = sqrt( hat.sig2 )

iter = iter + 1

 }
